#define F_CPU 16000000L

#include <avr/io.h>
#include <util/delay.h>
#include <util/atomic.h>
#include <stdlib.h>
#include <avr/sleep.h>
#include <avr/pgmspace.h>


typedef unsigned char bool;

struct recv_buffer
{
	char data[23];
	bool valid;
	char size;
};

struct LED_config
{
	signed int luminosity[4];
	char gamma;
		//0=>always on, use duty cycle instead; 1=>1.0(linear); 2=>1.8; 3=>2.0; 4=>2.2
	unsigned char duty; //0=>very short; 255=>always on
	unsigned char phase_offset;
};

void initialize_uart(void);
void send_response(int n);
void send_int(int n);
void send_char(char c);
volatile struct recv_buffer * get_next_data(void);

void initialize_leds(void);
void set_dac(unsigned char value, unsigned char bank);
void set_multi_dac(unsigned char value_0, unsigned char value_1, unsigned char value_2, unsigned char value_3);
void set_pwm(unsigned char address, unsigned int value, unsigned char bank);
void set_multi_pwm(unsigned char address, unsigned int value_0, unsigned int value_1, unsigned int value_2, unsigned int value_3);


extern volatile struct LED_config leds[8];
extern volatile unsigned char theta;

void initialize_timer(void);
void cancel_timer(void);
void set_timer_period(unsigned int t);

void power_down(void);

